#!/usr/bin/env python3.8
"""
The logic on widgets is here.
vehicle_logger_gui (Ui_Form) is generated automatically using pyuic5.
Furthur guide is under _ui folder.

"""
from PyQt5.QtGui import QGuiApplication
from importlib import util
import yaml

with open(r"gui_parameters.yaml", "r") as file:
    data = yaml.load(file, Loader=yaml.FullLoader)
    high_resolution = data['gui_resolution']['high_resolution']
if high_resolution == False:
    from _ui.vehicle_log_gui import Ui_Form as vehicle_logger_gui
else:
    from _ui.vehicle_log_gui_high_res import Ui_Form as vehicle_logger_gui


class vehicle_log_gui_logic(vehicle_logger_gui):
    def __init__(self) -> None:
        super().__init__()

    def set_initial_btn_state(self):
        self.get_vehicle_logs_btn.setEnabled(True)
        self.load_file_btn.setEnabled(True)
        self.start_logging_btn.setEnabled(False)
        self.fetch_tdf_btn.setEnabled(False)
        self.get_sw_info_btn.setEnabled(True)
        self.decode_btn.setEnabled(False)
        self.can_check_btn.setEnabled(False)
        self.aeb_pytest_btn.setEnabled(True)
        self.all_pytest_btn.setEnabled(True)
        self.aeb_analysis_btn.setEnabled(False)
        self.ms_signal_analysis_btn.setEnabled(False)
        self.aam_signal_analysis_btn.setEnabled(False)
        self.domain_controller_signal_analysis_btn.setEnabled(False)
        self.fault_matrix_btn.setEnabled(False)
        self.generate_report_btn.setEnabled(False)
        self.deploy_btn.setEnabled(False)
        self.Comment_btn.setEnabled(True)
        self.get_app_state_btn.setEnabled(False)
        self.sga2hpa_btn.setEnabled(False)
        self.get_ip_vin_btn.setEnabled(False)
        self.FM_quick_check_btn.setEnabled(False)
        self.ClearDTC_btn.setEnabled(False)
        self.DisableFirewall_btn.setEnabled(False)
        self.get_vehicle_logs_btn.setEnabled(False)
        self.pack_logs_btn.setEnabled(False)
        self.get_sw_info_btn.setEnabled(False)
        self.update_tdf_btn.setEnabled(False)
        self.can_check_btn.setEnabled(False)
        self.aeb_analysis_btn.setEnabled(False)
        self.ms_signal_analysis_btn.setEnabled(False)
        self.aam_signal_analysis_btn.setEnabled(False)
        self.domain_controller_signal_analysis_btn.setEnabled(False)
        self.health_monitor_fault_btn.setEnabled(False)
        self.dl_adas_a2l_s19__btn.setEnabled(False)
        self.ena_aeb_fcw_dc_btn.setEnabled(False)
        self.ena_rsi_btn.setEnabled(False)
        self.ena_ddaw_btn.setEnabled(False)
        self.ena_lka_btn.setEnabled(False)
        self.ena_pa_btn.setEnabled(False)
        self.ena_pap_btn.setEnabled(False)
        self.progressBar.setProperty("value", 0)
        if not util.find_spec("xcplib"):
            self.dl_adas_a2l_s19__btn.setEnabled(False)
            self.ena_aeb_fcw_dc_btn.setEnabled(False)
            self.ena_rsi_btn.setEnabled(False)
            self.ena_ddaw_btn.setEnabled(False)
            self.ena_lka_btn.setEnabled(False)
            self.ena_pa_btn.setEnabled(False)
            self.ena_pap_btn.setEnabled(False)

    def set_function_is_active_state(self, hostlog_active = False):
        if not hostlog_active:
            self.start_logging_btn.setEnabled(False)
        self.get_vehicle_logs_btn.setEnabled(False)
        self.load_file_btn.setEnabled(False)
        self.fetch_tdf_btn.setEnabled(False)
        self.get_sw_info_btn.setEnabled(False)
        self.decode_btn.setEnabled(False)
        self.deploy_btn.setEnabled(False)
        self.pack_logs_btn.setEnabled(False)
        self.Comment_btn.setEnabled(True)
        self.can_check_btn.setEnabled(False)
        self.get_app_state_btn.setEnabled(False)
        self.sga2hpa_btn.setEnabled(False)
        self.get_ip_vin_btn.setEnabled(False)
        self.get_vehicle_logs_btn.setEnabled(False)
        self.pack_logs_btn.setEnabled(False)
        self.update_tdf_btn.setEnabled(False)
        self.can_check_btn.setEnabled(False)
        self.aeb_analysis_btn.setEnabled(False)
        self.ms_signal_analysis_btn.setEnabled(False)
        self.aam_signal_analysis_btn.setEnabled(False)
        self.domain_controller_signal_analysis_btn.setEnabled(False)
        self.fault_matrix_btn.setEnabled(False)
        self.dl_adas_a2l_s19__btn.setEnabled(False)
        self.ena_aeb_fcw_dc_btn.setEnabled(False)
        self.ena_rsi_btn.setEnabled(False)
        self.ena_ddaw_btn.setEnabled(False)
        self.ena_lka_btn.setEnabled(False)
        self.ena_pa_btn.setEnabled(False)
        self.ena_pap_btn.setEnabled(False)
        self.make_tracebuffer_btn.setEnabled(False)
        self.make_bundle_btn.setEnabled(False)
        self.sanity_check_btn.setEnabled(False)
        self.health_monitor_fault_btn.setEnabled(False)
        self.download_hostlog_btn.setEnabled(False)
        self.FM_quick_check_btn.setEnabled(False)
        self.ClearDTC_btn.setEnabled(False)
        self.DisableFirewall_btn.setEnabled(False)
        QGuiApplication.processEvents()

    def set_waiting_for_request_state(self):
        self.get_vehicle_logs_btn.setEnabled(True)
        self.load_file_btn.setEnabled(True)
        self.start_logging_btn.setEnabled(True)
        self.fetch_tdf_btn.setEnabled(True)
        self.get_sw_info_btn.setEnabled(True)
        self.decode_btn.setEnabled(True)
        self.deploy_btn.setEnabled(True)
        self.pack_logs_btn.setEnabled(True)
        self.Comment_btn.setEnabled(True)
        self.can_check_btn.setEnabled(True)
        self.get_app_state_btn.setEnabled(True)
        self.sga2hpa_btn.setEnabled(True)
        self.get_ip_vin_btn.setEnabled(True)
        self.FM_quick_check_btn.setEnabled(True)
        self.ClearDTC_btn.setEnabled(True)
        self.DisableFirewall_btn.setEnabled(True)
        self.get_vehicle_logs_btn.setEnabled(True)
        self.pack_logs_btn.setEnabled(True)
        self.update_tdf_btn.setEnabled(True)
        self.can_check_btn.setEnabled(True)
        self.aeb_analysis_btn.setEnabled(True)
        self.ms_signal_analysis_btn.setEnabled(True)
        # self.aam_signal_analysis_btn.setEnabled(True)
        self.domain_controller_signal_analysis_btn.setEnabled(True)
        self.fault_matrix_btn.setEnabled(True)
        self.dl_adas_a2l_s19__btn.setEnabled(True)
        self.ena_aeb_fcw_dc_btn.setEnabled(True)
        self.ena_rsi_btn.setEnabled(True)
        self.ena_ddaw_btn.setEnabled(True)
        self.ena_lka_btn.setEnabled(True)
        self.ena_pa_btn.setEnabled(True)
        self.ena_pap_btn.setEnabled(True)
        self.make_tracebuffer_btn.setEnabled(True)
        self.make_bundle_btn.setEnabled(True)
        self.sanity_check_btn.setEnabled(True)
        self.health_monitor_fault_btn.setEnabled(True)
        self.download_hostlog_btn.setEnabled(True)
        self.FM_quick_check_btn.setEnabled(True)
        self.ClearDTC_btn.setEnabled(True)
        self.DisableFirewall_btn.setEnabled(True)
        self.all_pytest_btn.setEnabled(True)
        self.aeb_pytest_btn.setEnabled(True)
        self.lat_pytest_btn.setEnabled(True)
        self.rsi_pytest_btn.setEnabled(True)
        self.ddaw_pytest_btn.setEnabled(True)
        self.pa_pytest_btn.setEnabled(True)
        self.pap_pytest_btn.setEnabled(True)
        self.progressBar.setProperty("value", 0)
        QGuiApplication.processEvents()
